<?php

/**
 * The public-facing functionality of the plugin.
 *
 * @link       http://example.com
 * @since      1.0.0
 *
 * @package    Plugin_Name
 * @subpackage Plugin_Name/public
 */

/**
 * The public-facing functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the admin-specific stylesheet and JavaScript.
 *
 * @package    Plugin_Name
 * @subpackage Plugin_Name/public
 * @author     Your Name <email@example.com>
 */
class CMP_Public {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of the plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {

		$this->plugin_name = $plugin_name;
		$this->version = $version;
	}

	/**
	 * Register the stylesheets for the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_styles() {
		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in Plugin_Name_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The Plugin_Name_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */
		wp_enqueue_style( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'css/cmp-public.css', array(), $this->version, 'all' );
	}

	/**
	 * Register the JavaScript for the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function enqueue_scripts() {

		/**
		 * This function is provided for demonstration purposes only.
		 *
		 * An instance of this class should be passed to the run() function
		 * defined in Plugin_Name_Loader as all of the hooks are defined
		 * in that particular class.
		 *
		 * The Plugin_Name_Loader will then create the relationship
		 * between the defined hooks and the functions defined in this
		 * class.
		 */

		wp_enqueue_script( $this->plugin_name, plugin_dir_url( __FILE__ ) . 'js/cmp-public.js', array( 'jquery' ), $this->version, true );
		wp_localize_script( $this->plugin_name,'ajaxobject', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );

	}
	
	public function cmp_widget_shortcode($atts){  
	    
			$atts = shortcode_atts( array(
				'list' => '',
				'template' => ''
			), $atts, 'CF7A' ); 
			global $wpdb;
			$list_id = $atts['list'];
			$template = $atts['template'];
		
			$result = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."cmp_template_data WHERE list_id = '".$list_id."' and template_id = '".$template."'  "); 
			
			if($wpdb->num_rows>0){
				foreach($result as $results){
					$data = json_decode($results->data,true);
					$title = isset($data['cmp_templete_title'])?$data['cmp_templete_title']:'';
					$btn_txt = isset($data['cmp_templete_button_text'])?$data['cmp_templete_button_text']:'';;
					$desc = isset($data['cmp_templete_popup_desp'])?$data['cmp_templete_popup_desp']:'';
					$sub_title = isset($data['cmp_templete_popup_subtit'])?$data['cmp_templete_popup_subtit']:'';
					$name_placeholder = isset($data['cmp_templete_popup_name_ph'])?$data['cmp_templete_popup_name_ph']:'';
					$email_placeholder = isset($data['cmp_templete_popup_email_ph'])?$data['cmp_templete_popup_email_ph']:'';
					$bg_clr = isset($data['cmp_templete_bgclr'])?$data['cmp_templete_bgclr']:'';
					$bg_txt_clr = isset($data['cmp_templete_txt_clr'])?$data['cmp_templete_txt_clr']:'';
					$desc_clr = isset($data['cmp_templete_popup_desp_clr'])?$data['cmp_templete_popup_desp_clr']:'';
					$subtitle_clr = isset($data['cmp_templete_popup_subtit_clr'])?$data['cmp_templete_popup_subtit_clr']:'';
					$border_clr = isset($data['cmp_templete_bdrclr'])?$data['cmp_templete_bdrclr']:'';
					$btn_bg_clr = isset($data['cmp_templete_btn_bgclr'])?$data['cmp_templete_btn_bgclr']:'';
					$btn_txt_clr = isset($data['cmp_templete_btn_txtclr'])?$data['cmp_templete_btn_txtclr']:'';
					$btn_hvr_clr = isset($data['cmp_templete_btn_hvrclr'])?$data['cmp_templete_btn_hvrclr']:'';
					$image= isset($data['cmp_event_image_upload'])?$data['cmp_event_image_upload']:'';
					$logo = isset($data['cmp_event_logo_upload'])?$data['cmp_event_logo_upload']:'';
					$plh_clr = isset($data['cmp_templete_plcclr'])?$data['cmp_templete_plcclr']:'';
					
					$content ='<div class="cmp_temp_wrapper"><div id="public_template" style="display: none;" >'.$template.'</div><div id="public_plcclr" style="display: none;">'.$plh_clr.'</div>';
					if($template == "temp1"){
						$content .= '<div id="temp1">
							<div class="temp1_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; "> 
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<h1 class="form_heading" data-title="Subscribe Here" style="color:'.$bg_txt_clr.'; ">'.$title.'</h1>
									<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
									<input type="text" name="name" id="name" placeholder="'.$name_placeholder.'" value="" />
									<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
									<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.'; " />
									<span id="popup_response_err" class="popup_response_err" ></span> 
								</form>
							</div>
						</div>';
					
					}else if($template == "temp2"){
						$content .= '<div id="temp2">
							<div class="temp2_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">
								<h1 data-title="subscribe to our newsletter" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp2_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
							</div>
						</div>';
					}else if($template == "temp3"){
						$content .= '<div id="temp3">
							<div class="temp3_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">';
								if($logo == ""){
									$content .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/email_t7.png'.' ">';
								}else{
									$content .= '<img src=" '.$logo.' ">';
								}
								
						$content .= '<h1 data-title="subscribe to the newsletter" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp3_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
							</div>
						</div>';
					}else if($template == "temp4"){
						$content .= '<div id="temp4">
							<div class="temp4_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; " >
								<h3 style="color:'.$subtitle_clr.'; " >'.$sub_title.'</h3>
								<h1 data-title="30% discount" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp4_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div> 
								</form>
							</div>
						</div>';
					}else if($template == "temp5"){
						$content .= '<div id="temp5" >
							<div class="temp5_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">
								<h1  data-title="subscribe to the newsletter" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp5_input">
										<input type="text" name="name" id="name" placeholder="'.$name_placeholder.'"  style="color:'.$bg_txt_clr.'; "  />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" style="color:'.$bg_txt_clr.'; "  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  "  />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
							</div>
						</div>';
						
					}else if($template == "temp6"){
						$content .= '<div id="temp6">
							<div class="temp6_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; " >
								<div class="temp6_top_wrapper">
									<div class="temp6_icon">';
									if($logo == ""){
										$content .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/envelope_icon_2.png'.' ">';
									}else{
										$content .= '<img src=" '.$logo.' ">';
									}
								$content .= '</div>
									<div class="temp6_heading">
										<h1  data-title="subscribe" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
										<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
									</div>
								</div>
								<div class="temp6_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp6_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp7"){
						$content .= '<div id="temp7">
							<div class="temp7_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; ">
								<div class="temp7_top_wrapper">
									<div class="temp7_heading">
										<h3 style="color:'.$subtitle_clr.'; ">'.$sub_title.'</h3>
										<h1 data-title="NEWSLETTER" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>      
										<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
									</div>
									<div class="temp7_icon">';
									if($logo == ""){
										$content .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/temp_smily.png'.' ">';
									}else{
										$content .= '<img src=" '.$logo.' ">';
									}
									$content .= '</div>
								</div>
								<div class="temp7_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp7_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
									</div>
									<span id="popup_response_err" class="popup_response_err" ></span> 
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp8"){
						$content .= '<div id="temp8">
							<div class="temp8_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; "> 
								<div class="temp8_top_wrapper">
									<div class="temp8_icon">';
									if($logo == ""){
										$content .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/temp_offer.png'.' ">';
									}else{
										$content .= '<img src=" '.$logo.' ">';
									}
									$content .= '</div>
									<div class="temp8_heading"> 
										<h3 style="color:'.$subtitle_clr.'; ">'.$sub_title.'</h3>    
										<h1 data-title="30% off" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>
									</div>
								</div>
								<div class="temp8_input_wrapper">
								<p style="color:'.$desc_clr.'; ">'.$desc.'</p>
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp8_input">
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"   style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp9"){
						$content .= '<div id="temp9" style="background-color:'.$bg_clr.';  border-color:'.$border_clr.';  ">';
						if($image == ''){
							$content .= '<div class="temp9_wrapper" >';
						}else{
							$content .= '<div class="temp9_wrapper" style="background-image: url('.$image.');">';
						}
						   
								$content .= '<div class="temp9_top_wrapper">           
									<div class="temp9_heading">       
										<h1 data-title="newsletter" style="color:'.$bg_txt_clr.'; "  >'.$title.'</h1>
									</div>
								</div>
								<div class="temp9_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp9_input">
										<input type="text" name="name" id="name" placeholder="'.$name_placeholder.'" />
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  " />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>
						</div>';
						
					}else if($template == "temp10"){
						$content .= '<div id="temp10">
							<div class="temp10_wrapper" style="background-color:'.$bg_clr.'; border-color:'.$border_clr.'; " >               
								<div class="temp10_heading">
									<div class="temp10_icon">';
									if($logo == ""){
										$content .= '<img src=" '.plugin_dir_url( __DIR__ ).'public/images/email_img.png'.' ">';
									}else{
										$content .= '<img src=" '.$logo.' ">';
									}
									$content .= '</div>	 
									<h1 data-title="subscribe" style="color:'.$bg_txt_clr.'; " >'.$title.'</h1>  
									<p style="color:'.$desc_clr.'; " >'.$desc.'</p>
								</div>
								<div class="temp10_input_wrapper">
								<form name="cpm_temp_submit_form" action="'.$_SERVER['REQUEST_URI'].'" method="post" id="cpm_temp_submit_form">
									<div class="temp10_input">
										<input type="hidden" name="list_id" id="list_id" value="'.$list_id.'"  />
										<input type="text" name="email" id="email" placeholder="'.$email_placeholder.'" />
										<input type="submit" value="'.$btn_txt.'" class="cmp_subs_btn cmp_btn"  style="background-color:'.$btn_bg_clr.'; color:'.$btn_txt_clr.';  "  />
										<span id="popup_response_err" class="popup_response_err" ></span> 
									</div>
								</form>
								</div>
							</div>     
						</div>       
					</div>';
					}
					$content .= '</div>';
					
				$content .= "<script>
					jQuery('#".$template."  .cmp_subs_btn').hover(function() {
						jQuery( this ).css('background-color', '".$btn_hvr_clr."'); 
					  }, function() {
						  jQuery( this ).css('background-color', '".$btn_bg_clr."');
					  });  
				</script>";
				
				return $content;	
				}
				
			}
	}
	
	public function temp_form_submit(){
		$list_id = $_POST['temp_form__list_id'];
		$name= $_POST['temp_form_name'];
		$email = $_POST['temp_form_email'];
		//$merge_vars =array();  
		if(get_option('cmp_subscriber_settings')){ 
			$api_key =  get_option('cmp_subscriber_settings')['Mailchimp']['api_key'];
			$mcapi = new Mailchimp($api_key);
			$merge_vars['FNAME'] = $name; 
			if ($list_id != '') {
				if($name != ''){ 
					$retval = $mcapi->post('/lists/'.$list_id.'/members', array(
												'email_address' => $email,
												'merge_fields'  => $merge_vars,
												'status'        => 'subscribed'     
										));
					echo $retval['status'];
				}else{
					$retval = $mcapi->post('/lists/'.$list_id.'/members', array(
												'email_address' => $email,
					
												'status'        => 'subscribed'  
										));	
					echo $retval['status'];	
				}
			}else{
				echo "fail";
			}
			
		}  
		die();
	}
	
	public function cmp_mailchimp_cf7_submit($wpar){ 
		global $wpdb;
		//$currentformInstance  = WPCF7_ContactForm::get_current();  
		$submission = WPCF7_Submission::get_instance();
        if ($submission) {
            $formdata = $submission->get_posted_data();
        }
        $i = 0;
        // date_default_timezone_set('Asia/Kolkata');
        $today = date("Y-m-d H:i:s");
        $table_name  = $wpdb->prefix . 'cf7mailchimp_submits';
        $entry = $wpdb->get_results("SELECT MAX(entry_id) AS maxid FROM ".$table_name."");
        $final_entry = $entry[0]->maxid+1;				
        $skipvalue   = array(
            "_wpcf7_version",
            "_wpcf7_is_ajax_call",
            "_wpcf7_locale",
            "_wpcf7_unit_tag",
            "_wpnonce"
        ); 
		
       for ($j = 0; $j < count($skipvalue); $j++) {
          if (array_key_exists($skipvalue[$j], $formdata)) { 
               unset($formdata[$skipvalue[$j]]);
           } 
        } 
		$formdata = array_filter($formdata);
		$i =0;
		$newdata="";
        foreach ($formdata as $fieldname => $fieldvalue) {
            if ($i != 0) {
                $newdata .= ",";
            }
           if (is_array($fieldvalue)) {
                $fieldvalue = $fieldvalue[0];
            } else {
                $fieldvalue = $fieldvalue;
            }
            $newdata .= '("' . $today . '","' . $formdata['_wpcf7'] . '","' . $final_entry . '","' . $fieldname . '","' . $fieldvalue . '","' . $i . '","")'; 
            $i++; 
        } 
        $table_name = $wpdb->prefix . 'cf7mailchimp_submits';
        $wpdb->query('INSERT INTO ' . $table_name . '(`submit_time`,`form_id`,`entry_id`,`field_name`, `field_value`,`field_order`,`file`) VALUES ' . $newdata . ''); 
        if ($formdata['_wpcf7']) {
        	$resultsss = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."cmp_form_data WHERE form_id = '".$formdata['_wpcf7']."' ");
			$arlists =array();
			if($wpdb->num_rows>0){
				$i = 0;
				foreach($resultsss as $results){
					$arlists = $resultsss[$i]->list_id;
					$select_cf_fields = json_decode($resultsss[$i]->field_selected);
					for ($b = 0; $b < count($select_cf_fields); $b++) {
						if (array_key_exists($select_cf_fields[$b], $formdata)) {
							$cmp_formfield[]  = $formdata[$select_cf_fields[$b]];
					   } 
					}
			 
					$select_mailchimp_fields = json_decode($resultsss[$i]->mailchimp_list);
					
					$combined_cf_mailchimp = array_combine(array_intersect_key($select_mailchimp_fields, $cmp_formfield), array_intersect_key($cmp_formfield, $select_mailchimp_fields));
				    echo $this->contactformarsubmitter_onmailchimp($combined_cf_mailchimp,'mailchimp', $arlists); 
					$i++;
				} 
			} 	
        } 
		//return $currentformInstance; 
	}
	
	public function contactformarsubmitter_onmailchimp($combined_cf_mailchimp, $autoresponder = '', $listid = ''){
	    global $wpdb;   
	    $result         = array(); 
	    $errors         = array();
		
		if(get_option('cmp_subscriber_settings')){ 
			if(!empty($combined_cf_mailchimp)){
				$api_key =  get_option('cmp_subscriber_settings')['Mailchimp']['api_key'];
				$mcapi = new MCAPI($api_key);
				$cm_email = $combined_cf_mailchimp['EMAIL'];
				
				foreach($combined_cf_mailchimp as $k=>$v){					
							if($k != 'EMAIL' ){
								$merge_vars[$k] = $v;
							}
						}
				if ($listid != '') {
					$mailchimplist = $listid;
					$retval        = $mcapi->listSubscribe($mailchimplist, $cm_email, $merge_vars); 
				}
				if ($mcapi->errorCode) {
				} else {  
					$Done = 1; 
				} 
				
			}
		}
	  
	}
	
}